/* coding: utf-8 */
/* Copyright (C) 2018 SofTek Systems, Inc. */

//ヘッダーの履歴
$(function() {
    function create_history_hostname_elm(host_id, hostname, ext_name, vuls_amount, is_new_host){
        var item = $('<div>').attr({
            'class': 'w-100 dropright notify-history-hostname',
            'id': 'notify-host' + host_id,
            'data-hostid': host_id
        });
        var d_btn = $('<span>').attr({
            'class': 'text-left btn btn-xs text-nowrap text-truncate notify-history-hostname-btn',
            'title': 'ホスト名: ' + hostname + '<br/>表示名: ' + (ext_name ? ext_name : '(未設定)'),
            'data-toggle': 'tooltip',
            'data-html': 'true',
            'data-placement': 'top',
            'data-boundary': 'window'
        }).text(ext_name ? ext_name : hostname);
        item.append(d_btn);
        var badge = $('<span>').attr({
           'id': ('notify-mark-hostname-host-' + host_id + '-badge'),
           'class': 'badge badge-warning notify-mark-hostname'
        }).text(vuls_amount);
        var arrow = $('<span>').attr('class', 'dropdown-toggle hostname-arrow ml-2');
        item.append(badge, arrow);
        var d_menu = $('<div>').attr({
            'class': 'dropright text-nowrap'
        }).css('display', 'none');
        item.append(d_menu);
        if( is_new_host ){
            var elm_id = 'new-history-mark-host' + host_id;
            var add_new_mark = $('<span>').attr({'id': elm_id, 'class': 'new-history-mark'})
                                          .text('新着あり');
            item.append(add_new_mark).css('margin-top', '10px');
        }
        return item
    }

    function create_notify_history_titles(vuls_data, host_id){
        var elms = vuls_data.map(function(data){
            var html_id = data['html_id'];
            var title = data['title'];
            var is_new = data['is_new'];
            var host_path = url_host_detail(host_id);
            var vul_path = url_vulnerabilities_detail(html_id);
            var d_item = $('<div>').attr({
                'class': 'notify-history-title',
            });
            var d_item_btn = $('<a>').attr({
                'class': 'btn btn-xs notify-history-title-btn text-truncate g-radius-0 g-font-size-0_89x',
                'title': title,
            }).text(title);
            var d_arrow = $('<span>').attr('class', 'dropdown-toggle only-arrow mr-2');
            d_item.append(d_item_btn, d_arrow);
            if( is_new ){
                var add_new_mark_title = $('<span>').attr({
                    'class': 'new-history-mark-title'
                }).text('新着あり');
                d_item_btn.after(add_new_mark_title).css('max-width', '79%');
            }
            var d_item_menu = $('<div>').attr({
                'class': 'notify-history-link-menu text-nowrap',
                'data-scrollhtmlid': html_id
            }).css('display', 'none');
            var d_item_vul= $('<div>').attr('class', 'wrap-notify-history-link');
            var link_to_vul = $('<a>').attr({
                'data-action': vul_path,
                'class': 'notify-history-link p-1',
                'href': '#',
                'data-hostid': host_id
            }).text('脆弱性詳細ページへ');
            d_item_vul.append(link_to_vul);
            var d_item_host = $('<div>').attr('class', 'wrap-notify-history-link');
            var link_to_host = $('<a>').attr({
                'data-action': host_path,
                'class': 'notify-history-link p-1',
                'href': '#',
                'data-htmlid': html_id
            }).text('ホスト詳細ページへ');
            d_item_menu.append(d_item_vul, link_to_host);
            d_item_menu.append(d_item_host);
            d_item.append(d_item_menu);
            return d_item;
        });
        return elms;
    }

    function toggle_history_titles(button, host_id){
        $('.notify-history-hostname').find('.notify-history-hostname-btn').removeClass('bg-b');
        $('.notify-history-hostname').removeClass('bg-b');
        var titles_list = $('#notify-history-titles');
        var is_host_titles_elm = (titles_list.attr('data-targethostid') == host_id); 
        titles_list.remove();
        $('#notify-history-links').remove();
        if( !is_host_titles_elm ){
            var titles_area = $('<div>').attr({
                'id': 'notify-history-titles', 
                'class': 'dropright text-nowrap notify-history-titles-list',
                'data-targethostid': host_id
            });
            var get_history_vuls_path = $('#sidfm_internal_api_get_history_vuls_path').val();
            $.post(get_history_vuls_path,{'host_id': host_id}, function(vuls){
                var titles = create_notify_history_titles(vuls.slice(0, 10), host_id);//速く表示するために、10件表示だけさせて、後から追加する
                titles_area.append(titles); 
                setTimeout(function(){
                    $('#notify-history-titles').append(create_notify_history_titles(vuls.slice(10), host_id));
                },1);
            });
            $('body').append(titles_area.hide());
            var offset = button.offset();
            titles_area.offset({'top': offset.top, 'left': offset.left + button.outerWidth(true)}).show();
            button.find('.notify-history-hostname-btn').addClass('bg-b');
            button.addClass('bg-b');
            $('#notify-history-titles').on('scroll', function(){//scrollするとリンクの位置がおかしくなるので消去
                $('#notify-history-links').remove();
                $('.notify-history-link-menu').removeClass('link-displayed');
                $('.notify-history-title').removeClass('bg-b');
            });
        }
    }

    function append_histories_hosts(hosts_data, new_journals_amount, history_menu_elm){
        var new_hosts = [];
        var old_hosts = [];
        for(var k = 0; k < hosts_data.length; k++){
            target_data = hosts_data[k];
            var host_id = target_data['host_id'];
            var is_new = target_data['is_new'];
            var hostname_elm = create_history_hostname_elm(
                host_id,
                target_data['hostname'], 
                target_data['ext_name'],
                target_data['total_vuls'],
                is_new
            ); 
            var host_elm = $('#notify-host' + host_id);
            if( host_elm.length === 1 && target_data['is_new']){
                old_hosts.push('#notify-host' + host_id);
                new_hosts.push(hostname_elm);
            }else if(host_elm.length === 0 && !is_new){
                history_menu_elm.append(hostname_elm);
            }else if(host_elm.length === 0 && target_data['is_new']){
                new_hosts.push(hostname_elm);
            }
        }
        if( new_hosts.length > 0 ){
            $(old_hosts.join(', ')).remove();
            history_menu_elm.prepend(new_hosts);
        }
        if($('#notify-new-histroy').length === 0 && new_journals_amount > 0){
            var notify_new_history = $('<span>').attr({'id':'notify-new-history'})
                                                .text('新着の履歴があります');
            $('#notify-mark').text(new_journals_amount).append(notify_new_history).show();
            $('#notify-history').find('.fa-bell')
                                .removeClass('text-notify-none')
                                .addClass('text-notify');
        }
    }

    var get_journal_hosts_path = $('#sidfm_internal_api_get_journal_hosts_path').val();
    $.get(get_journal_hosts_path,
        function(data){
            var notify_mark = $('<div>').attr({ 
                'id': 'notify-mark',
                'class': 'notify-mark',
                'style': 'display:none;'
            });
            var history_dropdown = $('<div>').attr({'class': 'dropdown'});
            var history_btn = $('<button>').attr({
                'class': 'dropdown-toggle btn btn-xs text-nowrap',
                'data-toggle': 'dropdown',
                'aria-haspopup': 'true',
                'aria-expanded': 'false',
                'tabindex': '-1',
                'id': 'notify-history-button',
           });
           var history_bell = $('<a>').attr({
               'data-toggle': 'tooltip',
               'data-placement': 'bottom',
               'data-original-title': '作業履歴通知',
               'id': 'history-bell'
            });
            var bell = $('<i>').attr('class','fas fa-bell mr-1 g-mt-2 text-notify-none g-font-size-1_16x');
            history_bell.append(bell);
            history_btn.append(history_bell);
            history_btn.append(notify_mark);
            history_dropdown.append(history_btn);
            var history_menu = $('<div>').attr({
                'class': 'dropdown-menu',
                'id':'notify-history-menu'
            });
            history_dropdown.append(history_menu);
            $('#notify-history').append(history_dropdown);
            $('#history-bell').tooltip();
            var hosts_data = data['hosts'];
            var new_journals_amount = data['new_journals_amount']; 
            if( hosts_data.length > 0 ){
                append_histories_hosts(hosts_data, new_journals_amount, history_menu);
            }else{
                var no_history = $('<div>').attr('id', 'no-notify-history').text('履歴はありません');
                history_menu.append(no_history);
            }
                                                    
            $('#notify-history-menu').on('click', function(e){
                e.stopPropagation();
            });
            $('#notify-history-button').on('click', function(){
                $('#notify-history-links').remove();
                $('#notify-history-titles').remove();
                $('#notify-history').find('.displayed').removeClass('displayed');
                $('#notify-history').find('.link-displayed').removeClass('link-displayed');
                $('.notify-history-hostname, .notify-history-hostname-btn').removeClass('bg-b');
                $('#notify-history-menu').find('[data-toggle="tooltip"]').tooltip();
            });
            $('#notify-history-menu').on('click', '.notify-history-hostname', function(){
                var button = $(this)
                var host_id = button.attr('data-hostid');
                toggle_history_titles(button, host_id);
            });
            $(document).on('click','.notify-history-title', function(e){
                $('#notify-history-links').remove();
                var button = $(this);
                var target = $(this).find('.notify-history-link-menu');
                $('.notify-history-title').removeClass('bg-b');
                if(!target.hasClass('link-displayed')){
                    button.closest('.notify-history-hidden-menu').find('.link-displayed').removeClass('link-displayed');
                    target.addClass('link-displayed');
                    //scroll barが右側にある場合、bodyに要素を貼り付けないと、右側に要素が表示されない
                    var clone_target_links = target.clone(true).attr('id', 'notify-history-links');
                    $('body').append(clone_target_links);
                    clone_target_links.show();
                    var button_offset = button.offset();
                    clone_target_links.offset({'top': button_offset.top, 'left': button_offset.left + button.outerWidth()});
                    button.addClass('bg-b');
                }else{
                    target.removeClass('link-displayed');
                    button.removeClass('bg-b');
                }
                e.stopPropagation();
            });
            $(document).on('click', '.notify-history-link', function(e){
                e.preventDefault();
                var link_menu = $(this).closest('.notify-history-link-menu');
                var htmlid;
                var hostid;
                link_menu.find('.notify-history-link')
                         .each(function(){
                             var elm = $(this);
                             if(elm.data('htmlid')){
                                 htmlid = elm.data('htmlid');
                             }else if(elm.data('hostid')){
                                 hostid = elm.data('hostid');
                             }
                         });       
                var link = $(this);
                var input = $('#param_notify_history');
                var form = $('#form_notify_history');
                form.attr('action', link.data('action'));
                if(link.data('htmlid')){
                    input.val(JSON.stringify([link.data('htmlid'), hostid]));
                }else{
                    input.val(JSON.stringify([link.data('hostid'), htmlid]));
                }
                form.submit(); 
            });
            $('#notify-history-menu').parent().on('hide.bs.dropdown',function(){
                if($('#notify-history-titles').length > 0){
                    $('#notify-history-links').hide();
                    $('#notify-history-titles').hide();
                }
            });
            $('#notify-history-menu').parent().on('show.bs.dropdown',function(){
                $('#notify-history-links').show();
                $('#notify-history-titles').show();
            });

            $('#notify-history-menu').on('scroll', function(){
                /*var titles_list_elm = $('#notify-history-titles');
                var offset_target = $('.notify-history-hostname[data-hostid="' + titles_list_elm.attr('data-targethostid') + '"]');
                if( offset_target.length > 0 ){
                    titles_list_elm.offset({
                        'top': offset_target.offset().top
                    });
                }*/
                $('.notify-history-hostname').find('.notify-history-hostname-btn').removeClass('bg-b');
                $('.notify-history-hostname').removeClass('bg-b');
                $('#notify-history-links').remove();
                $('#notify-history-titles').remove();
            });

    });
   
 
    $(window).on('load',function(){
       $('#notify-history').css('top', ($('#HEADnavi').height() - 28));
       setInterval(function(){
           $.get(get_journal_hosts_path,function(data){
               $('.notify-history-hostname').find('.notify-history-hostname-btn').removeClass('bg-b');
               $('.notify-history-hostname').removeClass('bg-b');
               $('#notify-history-titles').remove();
               $('#notify-history-links').remove();
               var hosts_data = data['hosts'];
               var new_journals_amount = data['new_journals_amount'];
               if( new_journals_amount > 0 ){
                   $('#no-notify-history').remove();
               }
               append_histories_hosts(hosts_data, new_journals_amount, $('#notify-history-menu'));
           }); 
       },900000); 
           
   });
      
     
       $(window).on('resize', function(){
           $('#notify-history').css('top', ($('#HEADnavi').height() - $('#notify-history').height()));
           var history_menu = $('#notify-history-menu');
           var history_titles = $('#notify-history-titles');
           if(history_menu.length === 1){
               $('#notify-history-titles').offset({'left':history_menu.offset().left + history_menu.outerWidth(true)});
           }
           if(history_titles.length === 1){
               $('#notify-history-links').offset({'left': history_titles.offset().left + history_titles.outerWidth()});
           }
       });

       $('#execute-submit-comment').on('click', function(){
           var get_new_journal_timer = setInterval(function(){
               var journal_posted = $.cookie('journal_posted');
               if(journal_posted === 'success'){
                   $.removeCookie('journal_posted');
                   clearInterval(get_new_journal_timer);
               }else if(journal_posted === 'fail'){
                   $.removeCookie('journal_posted');
                   clearInterval(get_new_journal_timer);
               }
           }, 100);
           setTimeout(function(){clearInterval(get_new_journal_timer)}, 5000);
       });
});

