/* coding: utf-8 */
/* Copyright (C) 2021 Softek Systems. Inc. */

//履歴情報画面
function BootStrapTableCellStyle(value, row, index, field) {
    switch (field){
        case 'chkbox':
            return { classes: 'chk-box' };
        case 'created_on':
            return { classes: 'created_on text-center' };
        case 'login_name':
            return { classes: 'login_name' };i
        case 'operation':
            return { classes: 'operation_detail text-center' };
        case 'comment':
            return { classes: 'comment' };
        case 'vul_title':
            return { classes: 'vul_title' };
        case 'hostname':
            return { classes: 'hostname' };
        case 'status':
            return { classes: 'status text-center' };
        case 'due_date':
            return { classes: 'due_date text-center' };
        case 'ctags':
            return { classes: 'ctags' };
        default:
            return { classes: '' };
    }
}

$(function(){
    const summaryTableId = 'histories-summary-table';
    const summaryTableElm = $('#' + summaryTableId);
    const pageName = 'histories';

    $(window).on('scroll', function(){
        setPopupZindex($('#' + summaryTableId + ' [data-menu="edit-comment"]:visible'));
    });

    const enableEditComment = () => {
        $('#' + summaryTableId + ' [data-menu="edit-comment"]').on('click', function(e){
            e.stopPropagation();
        });

        $('#' + summaryTableId + ' [data-editfield="comment"]').on('input', function(){
            var j_id = $(this).attr('data-journalid');
            var original_comment = $('#original-comment-' + j_id).val();
            var edit_button = $('.edit-comment[data-journalid="' + j_id + '"]');
            if( original_comment === $(this).val() || $(this).val().length === 0){
                edit_button.prop('disabled', true);
            }else{
                edit_button.prop('disabled', false);
            }
        });

        $('#' + summaryTableId + ' .edit-comment').on('click', function(){
            var conf = confirm('本当に変更してもよろしいですか?');
            if( conf ){
                var j_id = $(this).attr('data-journalid');
                execute_edit_comment(j_id, false);
            }else{
                return false;
            }
        });

        $('#' + summaryTableId + ' .delete-comment').on('click', function(){
            var conf = confirm('本当に削除してもよろしいですか?');
            if( conf ){
                var j_id = $(this).attr('data-journalid');
                $('#edit-comment-delete-flg-' + j_id).val('true');
                execute_edit_comment(j_id, true);
            }else{
                return false;
            }
        });

        $('#' + summaryTableId + ' .open-edit-comment-menu[data-toggle="dropdown"]').parent().on('shown.bs.dropdown', function(){
            const menu = $(this).find('[data-menu]');
            setTimeout(() => {
                setPopupZindex(menu);
            });
        });

    };

    //サマリー表の動的処理のため(bootstrap-tableのため)にbindする。でないとイベントが効かない。
    const bindSummaryTableRowEvents = () => {
        enable_bootstrap_actions('#' + summaryTableId);
        enableEditComment();
        enableCtagListBalloon({ dynamicSummaryTable, getCtagsPath: $('#get-ctags-by-htmlid-path').val() });
    };

    sticky_control('SummaryTable', pageName);
    activate_sidebar_item('sidebar-item-history-manip');
    set_style_for_ActionArea_on_filter_dropdown_event();

    /*const bindSortSummaryTableEvents = () => {
        $(`#${summaryTableId} .sort-created_on`).on('click', function() {
            execSortSummaryTable('created_on', $(this))
        });
        $(`#${summaryTableId} .sort-login_name`).on('click', function() {
            execSortSummaryTable('login_name', $(this))
        });
        $(`#${summaryTableId} .sort-email`).on('click', function() {
            execSortSummaryTable('email_address', $(this))
        });
        $(`#${summaryTableId} .sort-operation`).on('click', function() {
            execSortSummaryTable('operation', $(this))
        });
        $(`#${summaryTableId} .sort-hostname`).on('click', function() {
            execSortSummaryTable('hostname', $(this))
        });
        $(`#${summaryTableId} .sort-vul_title`).on('click', function() {
            execSortSummaryTable('vul_title', $(this))
        });
        $(`#${summaryTableId} .sort-status`).on('click', function() {
            execSortSummaryTable('status', $(this))
        });
        $(`#${summaryTableId} .sort-due_date`).on('click', function() {
            execSortSummaryTable('due_date', $(this))
        });
    };*/

    const dynamicSummaryTable = new DynamicSummaryTable({
        summaryTableId,
        bindSummaryTableRowEventsFunction: bindSummaryTableRowEvents,
        pageName,
        allFilteredIdsId: 'all-journal-ids',
        chkboxSelector: `#${summaryTableId} .historySelect`,
        allChkboxSelector: `#${summaryTableId} .allSelect`,
        bulkBtnSelector: '.action-btn',
    });

    $('#pages_form').on('submit', function(){ set_summary_table_lines(pageName, $('#pages_per_page').val()) });    
 
    //dropdownのメニュー内をクリックした時にダイアログが閉じてしまうのを防ぐ
    $('.filter-item').on('click', function(e){
        e.stopPropagation();
    });

    const summaryTableFilter = new SummaryTableFilter({dynamicSummaryTable});
    summaryTableFilter.enableFilterChangeLink('.filter-change', []); //対応状況検索
    summaryTableFilter.enableFilterDate('.filter-date-preset', '#filter-date-form', '#reset-filter-date'); //期間指定検索
 
    summaryTableFilter.enableFilterRoles('#exec-filter-roles', '#reset-filter-roles'); //権限検索
    summaryTableFilter.enableFilteSearchItems('get-filter-data-path', [ 'users', 'hosts' ]); //ユーザ・ホスト検索
    summaryTableFilter.enableFilterMultipleCategories('#exec-filter-categories', '#reset-filter-categories'); //カテゴリ検索
    summaryTableFilter.enableFilterOperations('#exec-filter-opes', '#reset-filter-opes') //操作検索
    summaryTableFilter.enableFilterText(
       '#exec-filter-comment',
       '#reset-filter-comment',
       { fieldSelector: '#filter-comment-input', isExceptCheckboxElmId: 'filter-comment-is-except' },
       'comment'
    ); //コメント検索
    summaryTableFilter.enableFilterText(
       '#exec-filter-vuls',
       '#reset-filter-vuls',
       { fieldSelector: '#filter-vuls-input' },
       'vuls'
    ); //脆弱性検索
    summaryTableFilter.enableFilterCtags('#exec-filter-ctags', '#reset-filter-ctags'); //カスタムタグ検索
    summaryTableFilter.enableResetAllFilters('#filter-clear'); //全リセット

    function execute_edit_comment(journal_id, is_delete_comment){
       var path = $('#edit-comment-path').val();
       var text_area = $('#edit-comment-textarea-' + journal_id);
       var param = {
           'journal_id': journal_id,
           'comment': text_area.val(),
           'comment_delete_flg': is_delete_comment
       };
       (async () => {
           const roleOrCategoryError = await dynamicSummaryTable.checkRolesAndCatsBeforeAction({
               additionalAlertMessage: '更新に失敗しました。'
           });
           $.post(path, param, function(data){
               if( data['err_message'].length > 0 ){
                   alert(data['err_message']);
                   return false;
               }
               var comment_elm = $('#comment-' + journal_id);
               if( is_delete_comment ){
                   text_area.val('');
                   comment_elm.attr({ 'data-original-title': '' });
                   comment_elm.html('<span class="slanted-font">' + $('#deleted-comment-note').val() + '</span>');
                   $('.delete-comment[data-journalid="' + journal_id + '"]').prop('disabled', true);
               }else{
                   comment_elm.attr({ 'data-original-title': data['comment'] });
                   comment_elm.html(data['comment']);
                   $('.delete-comment[data-journalid="' + journal_id + '"]').prop('disabled', false);
               }
               $('.edit-comment[data-journalid="' + journal_id + '"]').prop('disabled', true);
               $('#original-comment-' + journal_id).val(data['comment']);
               var tooltip_target = $('#wrap-comment-' + journal_id);
               tooltip_target.tooltip('show');
               setTimeout(function(){
                   tooltip_target.tooltip('hide');
               }, 3000);
                
           });
        })();
    }

    //コメント一括編集
    
    function create_bulk_tr_elm(data){
        return $('<tr>').append(
            $('<td>').append($('<div>').attr('class', 'comment').text(data.comment)),
            $('<td>').append(
                $('<div>').html(
                            data.is_anonymous ? '<div class="text-danger">' + data.login + '</div>' : '<div class="user" data-toggle="tooltip" data-title="ログイン名: ' + data.login + '<br>氏名: ' + data.user_fullname + '<br>メールアドレス: ' + data.address + '" data-boundary="window" data-placement="right" data-html="true">' + data.login + '<br>' + '<i class="far fa-envelope mr-1"></i>' + data.address + '</div>'
                          )
            )
        );
    }

    $('#bulk-update-comment-btn').on('click', function(){
        $('body').append(create_loading_window());
        var path = $('#get-data-for-bulk-update-path').val();
        var target_tbody = $('#EditBulkCommentModalTbody');
        target_tbody.find('*').remove();
        $('#bulk-update-comment-is-delete-checkbox').prop('checked', false);
        $('#edit-bulk-comment-textarea').prop('disabled', false);
        $('#edit-bulk-comment-textarea').val('');
        (async () => {
            const roleOrCategoryError = await dynamicSummaryTable.checkRolesAndCatsBeforeAction();
            if( roleOrCategoryError ) return;
            $.post(path, { 'journal_ids': $('#pages_checked').val() }, function(histories){
                /*cnt = 0;
                while( cnt < 15 ){//先にmodalを開い時に表示される分だけ追加
                   var history = histories.shift();
                   if( !history ){
                       break;
                   }
                    target_tbody.append(create_bulk_tr_elm(history));
                    cnt += 1;
                }
                $('#checking-window').remove();
                $('#EditBulkCommentModal').modal('show');
                target_tbody.find('[data-toggle="tooltip"]').tooltip();
                var append_elm = setInterval(function(){
                    var history = histories.shift();
                    if( history ){
                        target_tbody.append(create_bulk_tr_elm(history)); 
                    }else{
                        clearInterval(append_elm);
                        target_tbody.find('[data-toggle="tooltip"]').tooltip();
                    }
                });*/
                target_tbody.append(
                    histories.map(history => create_bulk_tr_elm(history))
                );
                $('#checking-window').remove();
                $('#EditBulkCommentModal').modal('show');
            });
        })();
    });

    $('#EditBulkCommentModal').on('hide.bs.modal', function(){
        $(this).find('.scroll-table').scrollTop(0);
    });

    $('#bulk-update-comment-is-delete-checkbox').on('change', function(){
        if( $(this).prop('checked') ){
            $('#edit-bulk-comment-textarea').prop('disabled', true);
        }else{
            $('#edit-bulk-comment-textarea').prop('disabled', false);
        }
    });

    $('#exec-bulk-edit-comment').on('click', function(){
        /*var page_info = {
            'offset': $('#pages_offset').val(),
            'per_page': $('#pages_per_page').val(),
            'filters': JSON.parse($('#pages_filters').val()),
            'order': $('#pages_order').val()
        };
        $('#bulk-update-comment-page-info').val(JSON.stringify(page_info));
        $('#bulk-update-comment-ids').val($('#pages_checked').val());
        $('#form-bulk-update-comment').submit();*/
        if( !$('#bulk-update-comment-is-delete-checkbox').prop('checked') && !$('#edit-bulk-comment-textarea').val() ){
           alert('コメントを削除しない場合、コメント欄に1文字以上の入力が必須です。');
           return false;
        }
        let conf = confirm('本当に変更してもよろしいですか?');
        if( !conf ) return;
        const paramsData = {
            comment: $('#edit-bulk-comment-textarea').val(),
        };
        if( $('#bulk-update-comment-is-delete-checkbox').prop('checked') ) paramsData.comment_delete_flg = true;

        dynamicSummaryTable.executeProcessWithProgressBar({
            ids: JSON.parse($('#pages_checked').val()),
                paramsData,
                idsParamsName: 'journal_ids',
                path: $('#sidfm_histories_bulk_update_comment_path').val(),
        });   
    });

    //JSON/TSV出力
    $('#download-files-btn').on('click', function(){
        (async () => {
            const roleOrCategoryError = await dynamicSummaryTable.checkRolesAndCatsBeforeAction();
            if( roleOrCategoryError ) return;
            var path = $('#get-download-max-size-path').val();
            $.post(path, {'target': 'history_json_tsv'}, function(data){
                $('#json-tsv-max-download-size').text(data.max_size);
                $('#modalDownload').modal('show'); 
            });
        })();
    });

    $('#exec-download').on('click', function(){
        json_tsv_summary_table_progress_download($('#download_select').val(), $('#read-download-data-path').val(), { dynamicSummaryTable });
    });

    /*$('#form-download').on('submit', function(){
        $('#download_order').val($('#pages_order').val());
        $('#download_filters').val($('#pages_filters').val());
        $('#download_journal_ids').val($('#pages_checked').val());
    });*

    
    /*$('#exec-download').on('click', function(){     
        var prepare_path = $('#prepare-download-path').val();
        var params = {
            'download[journal_ids]' : $('#pages_checked').val(),
            'download[format]': $('#download_select').val(),
            'download[order]': $('#pages_order').val(),
            'download[filters]': $('#pages_filters').val()
        }

        $.post( prepare_path, params, function(data){
            if( data.is_err ){
                alert('エラーが発生しました。画面をリロードします。');
                $('#pages_form').submit();
            }
            var event_source = new EventSource($('#download-path').val());
   
            event_source.addEventListener("get_data", function(event) {
                //console.log(event.data);
            });

            event_source.addEventListener("done", function(event) {
                this.close();
                //console.log(event);
                console.log('&&&&&&')
            });
        });
    });*/
});
